- Aldebaran documentation |
- C++ Libraries |
- index

libqi-api 2.8.7.4

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | List of all members
qi::DynamicObjectBuilder Class Reference

`#include <dynamicobjectbuilder.hpp>`

## Public Member Functions
| DynamicObjectBuilder ()
| DynamicObjectBuilder (DynamicObject *dynobject, bool deleteOnDestroy=true)
| ~DynamicObjectBuilder ()
template<typename OBJECT_TYPE , typename METHOD_TYPE >
unsigned int | advertiseMethod (const std::string &name, OBJECT_TYPE object, METHOD_TYPE method, const std::string &desc="", MetaCallType threadingModel=MetaCallType_Auto)
template<typename FUNCTION_TYPE >
unsigned int | advertiseMethod (const std::string &name, FUNCTION_TYPE function, const std::string &desc="", MetaCallType threadingModel=MetaCallType_Auto)
template<typename OBJECT_TYPE , typename METHOD_TYPE >
unsigned int | advertiseMethod (MetaMethodBuilder &builder, OBJECT_TYPE object, METHOD_TYPE method, MetaCallType threadingModel=MetaCallType_Auto)
template<typename FUNCTION_TYPE >
unsigned int | advertiseMethod (MetaMethodBuilder &builder, FUNCTION_TYPE function, MetaCallType threadingModel=MetaCallType_Auto)
template<typename T , typename... Args>
unsigned int | advertiseFactory (const std::string &name)
template<typename... Args>
unsigned int | advertiseSignal (const std::string &name)
template<typename T >
unsigned int | advertiseSignalF (const std::string &name)
| Advertise a signal using a function signature. More...
unsigned int | advertiseSignal (const std::string &name, qi::SignalBase *signal)
template<typename T >
unsigned int | advertiseProperty (const std::string &name)
unsigned int | advertiseProperty (const std::string &name, qi::PropertyBase *sig)
| Ownership is transferred to the object. More...
void | setThreadingModel (ObjectThreadingModel model)
unsigned int | xAdvertiseMethod (const Signature &sigret, const std::string &name, const Signature &signature, AnyFunction func, const std::string &desc="", MetaCallType threadingModel=MetaCallType_Auto)
unsigned int | xAdvertiseMethod (MetaMethodBuilder &builder, AnyFunction func, MetaCallType threadingModel=MetaCallType_Auto)
unsigned int | xAdvertiseSignal (const std::string &name, const Signature &signature, bool isSignalProperty=false)
unsigned int | xAdvertiseProperty (const std::string &name, const Signature &sig, int id=-1)
void | setDescription (const std::string &desc)
qi::AnyObject | object (boost::function< void(GenericObject *)> onDelete=boost::function< void(GenericObject *)>())
template<typename T >
qi::AnyObject | object (boost::shared_ptr< T > other)
| Return an AnyObject that shares life type with `other`. More...
void | markProperty (unsigned int ev, unsigned int getter, unsigned int setter)

## Detailed Description

Definition at line 18 of file dynamicobjectbuilder.hpp.

## Constructor & Destructor Documentation

qi::DynamicObjectBuilder::DynamicObjectBuilder | ( |  | ) |

qi::DynamicObjectBuilder::DynamicObjectBuilder | ( | DynamicObject * | dynobject,
|  | bool | deleteOnDestroy = `true`
| ) |  |

qi::DynamicObjectBuilder::~DynamicObjectBuilder | ( |  | ) |

## Member Function Documentation

template<typename T , typename... Args>

unsigned int qi::DynamicObjectBuilder::advertiseFactory | ( | const std::string & | name | ) |
| inline

create a T, wrap in a AnyObject All template parameters are given to the T constructor except the first one

Definition at line 58 of file dynamicobjectbuilder.hpp.

template<typename OBJECT_TYPE , typename METHOD_TYPE >

unsigned int qi::DynamicObjectBuilder::advertiseMethod | ( | const std::string & | name,
|  | OBJECT_TYPE | object,
|  | METHOD_TYPE | method,
|  | const std::string & | desc = `""`,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`
| ) |  |
| inline

Definition at line 32 of file dynamicobjectbuilder.hxx.

template<typename FUNCTION_TYPE >

unsigned int qi::DynamicObjectBuilder::advertiseMethod | ( | const std::string & | name,
|  | FUNCTION_TYPE | function,
|  | const std::string & | desc = `""`,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`
| ) |  |
| inline

Definition at line 17 of file dynamicobjectbuilder.hxx.

template<typename OBJECT_TYPE , typename METHOD_TYPE >

unsigned int qi::DynamicObjectBuilder::advertiseMethod | ( | MetaMethodBuilder & | builder,
|  | OBJECT_TYPE | object,
|  | METHOD_TYPE | method,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`
| ) |  |
| inline

Definition at line 59 of file dynamicobjectbuilder.hxx.

template<typename FUNCTION_TYPE >

unsigned int qi::DynamicObjectBuilder::advertiseMethod | ( | MetaMethodBuilder & | builder,
|  | FUNCTION_TYPE | function,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`
| ) |  |
| inline

Definition at line 48 of file dynamicobjectbuilder.hxx.

template<typename T >

unsigned int qi::DynamicObjectBuilder::advertiseProperty | ( | const std::string & | name | ) |

Definition at line 81 of file dynamicobjectbuilder.hxx.

unsigned int qi::DynamicObjectBuilder::advertiseProperty | ( | const std::string & | name,
|  | qi::PropertyBase * | sig
| ) |  |

Ownership is transferred to the object.

template<typename... Args>

unsigned int qi::DynamicObjectBuilder::advertiseSignal | ( | const std::string & | name | ) |

Definition at line 71 of file dynamicobjectbuilder.hxx.

unsigned int qi::DynamicObjectBuilder::advertiseSignal | ( | const std::string & | name,
|  | qi::SignalBase * | signal
| ) |  |

template<typename T >

unsigned int qi::DynamicObjectBuilder::advertiseSignalF | ( | const std::string & | name | ) |

Advertise a signal using a function signature.

Definition at line 76 of file dynamicobjectbuilder.hxx.

void qi::DynamicObjectBuilder::markProperty | ( | unsigned int | ev,
|  | unsigned int | getter,
|  | unsigned int | setter
| ) |  |

qi::AnyObject qi::DynamicObjectBuilder::object | ( | boost::function< void(GenericObject *)> | onDelete = `boost::function< void(GenericObject *)>()` | ) |

template<typename T >

qi::AnyObject qi::DynamicObjectBuilder::object | ( | boost::shared_ptr< T > | other | ) |

Return an AnyObject that shares life type with `other`.

Definition at line 89 of file dynamicobjectbuilder.hxx.

void qi::DynamicObjectBuilder::setDescription | ( | const std::string & | desc | ) |

void qi::DynamicObjectBuilder::setThreadingModel | ( | ObjectThreadingModel | model | ) |

unsigned int qi::DynamicObjectBuilder::xAdvertiseMethod | ( | const Signature & | sigret,
|  | const std::string & | name,
|  | const Signature & | signature,
|  | AnyFunction | func,
|  | const std::string & | desc = `""`,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`
| ) |  |

unsigned int qi::DynamicObjectBuilder::xAdvertiseMethod | ( | MetaMethodBuilder & | builder,
|  | AnyFunction | func,
|  | MetaCallType | threadingModel = `MetaCallType_Auto`
| ) |  |

unsigned int qi::DynamicObjectBuilder::xAdvertiseProperty | ( | const std::string & | name,
|  | const Signature & | sig,
|  | int | id = `-1`
| ) |  |

unsigned int qi::DynamicObjectBuilder::xAdvertiseSignal | ( | const std::string & | name,
|  | const Signature & | signature,
|  | bool | isSignalProperty = `false`
| ) |  |

The documentation for this class was generated from the following files:

- /home/opennao/work/release-2.8/sdk/libqi/qi/type/dynamicobjectbuilder.hpp
- /home/opennao/work/release-2.8/sdk/libqi/qi/type/detail/dynamicobjectbuilder.hxx